"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = prompting;

var _yoBasePrompts = _interopRequireDefault(require("yo-base-prompts"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function prompting(_x) {
  return _prompting.apply(this, arguments);
}

function _prompting() {
  _prompting = _asyncToGenerator(function* (yo) {
    const yoBasePrompts = new _yoBasePrompts.default(yo);

    const _ref = yield yoBasePrompts.prompt({
      authorEmail: true,
      authorName: true,
      authorUrl: true,
      description: true,
      destination: true,
      githubUsername: true,
      homepage: true,
      license: true,
      name: true,
      repository: true,
      version: true
    }),
          authorEmail = _ref.authorEmail,
          authorName = _ref.authorName,
          authorUrl = _ref.authorUrl,
          description = _ref.description,
          destination = _ref.destination,
          githubUsername = _ref.githubUsername,
          homepage = _ref.homepage,
          license = _ref.license,
          name = _ref.name,
          repository = _ref.repository,
          version = _ref.version;

    const keywords = [name];

    for (;;) {
      const _ref2 = yield yo.prompt([{
        type: 'input',
        name: 'keyword',
        message: 'Keyword:'
      }]),
            keyword = _ref2.keyword;

      if (keyword === '') break;
      keywords.push(keyword);
    }

    const _ref3 = yield yo.optionOrPrompt([{
      type: 'confirm',
      name: 'bin',
      message: 'Project is a bin',
      default: false
    }, {
      type: 'confirm',
      name: 'lock',
      message: 'Support package-lock.json',
      default: false
    }, {
      type: 'confirm',
      name: 'install',
      message: 'Install dependencies',
      default: true
    }]),
          install = _ref3.install,
          bin = _ref3.bin,
          lock = _ref3.lock;

    yo.answers = {
      authorEmail,
      authorName,
      authorUrl,
      bin,
      lock,
      description,
      destination,
      githubUsername,
      homepage,
      install,
      keywords,
      license,
      name,
      repository,
      version
    };

    if ((yield yo.optionOrPrompt([{
      type: 'confirm',
      name: 'generatorGithubProject',
      message: 'Generator GitHub Project:',
      default: true
    }])).generatorGithubProject) {
      yo.composeWith(require.resolve('generator-github-project'), _objectSpread({}, yo.answers, {
        template: 'minimal'
      }));
    }

    yo.context = _objectSpread({}, yo.context, yo.answers);
  });
  return _prompting.apply(this, arguments);
}